import csv
from .constants import WOO_IMP_EXP_PRODUCT_FIELDS, WOO_IMP_EXP_CATEGORY_FIELDS


class Wooifier(object):
    adapter_cls = None

    def __init__(self, adapter_cls):
        self.adapter_cls = adapter_cls

    def wooify(self, input_file, products_file, categories_file=None):
        adapter = self.adapter_cls(input_file)
        with open(products_file, 'w') as csv_products:
            products_writer = csv.DictWriter(
                csv_products,
                fieldnames=[f for f, d in WOO_IMP_EXP_PRODUCT_FIELDS])
            products_writer.writeheader()
            for product in adapter.clean_products:
                    products_writer.writerow(product)

        if categories_file and adapter.categories:
            with open(categories_file, 'w') as csv_categories:
                categories_writer = csv.DictWriter(
                    csv_categories,
                    fieldnames=[f for f, d in WOO_IMP_EXP_CATEGORY_FIELDS])
                categories_writer.writeheader()
                for category in list(adapter.categories):
                    categories_writer.writerow(category)
